怎么解决django__init__() takes 1 positional argument but 2 were given?

我在使用django框架制作网页的时候报错__init__() takes 1 positional argument but 2 were given。本来网页是没有错误的,只是添加登录界面之后点击登录就会报错。
这是login.html。
图片说明
base.html父模板。
图片说明
urls.py
图片说明
报错内容。
图片说明
自己是大部分按照《Python编程从入门到实践》写的,前面Learning Log没有问题,就是user有问题。
图片说明
谁会解决先提前谢谢了!

Csdn user default icon
上传中...
上传图片
插入图片
抄袭、复制答案,以达到刷声望分或其他目的的行为,在CSDN问答是严格禁止的,一经发现立刻封号。是时候展现真正的技术了!
其他相关推荐
TypeError: __init__() takes 1 positional argument but 2 were given?

![图片说明](https://img-ask.csdn.net/upload/201903/28/1553741593_305116.png) 不知道怎么解决

django.db.utils.InternalError: (1050, "Table 'django_content_type' already exists") 迁移文件建立数据表的时候一直报错

django.db.utils.InternalError: (1050, "Table 'django_content_type' already exists") 在网上看到很多的方法,大概都是 先删除 所有的迁移文件, 再删除 数据库中对应的 Django_migrations 表里面的所有数据 之后再进行创建迁移文件然后再执行创建数据表的操作,但是报 没有应用啥啥啥的错误。。。 接着执行: python manage.py migrate booktest --fake 结果再执行 : python manage.py migrate 还是报 1050 的错误。。。。。。。。 下面附上详细报错信息,求网友大哥们解答~~!! (django_py3) huangdonglin@huangdonglin-virtual-machine:~/django_show/test2$ python manage.py migrate Operations to perform: Synchronize unmigrated apps: messages, staticfiles Apply all migrations: admin, booktest, sessions, auth, contenttypes Synchronizing apps without migrations: Creating tables... Running deferred SQL... Installing custom SQL... Running migrations: Rendering model states... DONE Applying contenttypes.0001_initial...Traceback (most recent call last): File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/backends/utils.py", line 62, in execute return self.cursor.execute(sql) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/backends/mysql/base.py", line 124, in execute return self.cursor.execute(query, args) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/cursors.py", line 170, in execute result = self._query(query) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/cursors.py", line 328, in _query conn.query(q) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/connections.py", line 517, in query self._affected_rows = self._read_query_result(unbuffered=unbuffered) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/connections.py", line 732, in _read_query_result result.read() File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/connections.py", line 1075, in read first_packet = self.connection._read_packet() File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/connections.py", line 684, in _read_packet packet.check_error() File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/protocol.py", line 220, in check_error err.raise_mysql_exception(self._data) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/err.py", line 109, in raise_mysql_exception raise errorclass(errno, errval) pymysql.err.InternalError: (1050, "Table 'django_content_type' already exists") The above exception was the direct cause of the following exception: Traceback (most recent call last): File "manage.py", line 10, in <module> execute_from_command_line(sys.argv) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/core/management/__init__.py", line 338, in execute_from_command_line utility.execute() File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/core/management/__init__.py", line 330, in execute self.fetch_command(subcommand).run_from_argv(self.argv) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/core/management/base.py", line 390, in run_from_argv self.execute(*args, **cmd_options) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/core/management/base.py", line 441, in execute output = self.handle(*args, **options) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/core/management/commands/migrate.py", line 221, in handle executor.migrate(targets, plan, fake=fake, fake_initial=fake_initial) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/migrations/executor.py", line 110, in migrate self.apply_migration(states[migration], migration, fake=fake, fake_initial=fake_initial) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/migrations/executor.py", line 147, in apply_migration state = migration.apply(state, schema_editor) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/migrations/migration.py", line 115, in apply operation.database_forwards(self.app_label, schema_editor, old_state, project_state) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/migrations/operations/models.py", line 59, in database_forwards schema_editor.create_model(model) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/backends/base/schema.py", line 286, in create_model self.execute(sql, params or None) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/backends/base/schema.py", line 111, in execute cursor.execute(sql, params) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/backends/utils.py", line 79, in execute return super(CursorDebugWrapper, self).execute(sql, params) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/backends/utils.py", line 64, in execute return self.cursor.execute(sql, params) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/utils.py", line 97, in __exit__ six.reraise(dj_exc_type, dj_exc_value, traceback) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/utils/six.py", line 658, in reraise raise value.with_traceback(tb) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/backends/utils.py", line 62, in execute return self.cursor.execute(sql) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/django/db/backends/mysql/base.py", line 124, in execute return self.cursor.execute(query, args) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/cursors.py", line 170, in execute result = self._query(query) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/cursors.py", line 328, in _query conn.query(q) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/connections.py", line 517, in query self._affected_rows = self._read_query_result(unbuffered=unbuffered) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/connections.py", line 732, in _read_query_result result.read() File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/connections.py", line 1075, in read first_packet = self.connection._read_packet() File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/connections.py", line 684, in _read_packet packet.check_error() File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/protocol.py", line 220, in check_error err.raise_mysql_exception(self._data) File "/home/huangdonglin/.virtualenvs/django_py3/lib/python3.6/site-packages/pymysql/err.py", line 109, in raise_mysql_exception raise errorclass(errno, errval)

python __init__方法子类如何在继承父类的基础上进行拓展

举例说明: class A(): def __init__(self,name,age): self.name =name self.age = age class B(A): def __init__(self,score): pass 问题:如何设置,让B类在创建实例对象时,name和age必填,score可以进行选填

django同步send_email正常,celery异步send_email报错Connection unexpectedly closed

@shared_task def sendEmail(content): try: send_mail('主题',content,'abc@qq.com',['1001@qq.com','1002@qq.com']) print('发送成功') except SMTPException as e: print(f'发送失败{e}') #views.py …… #sendEmail('同步发送信息') ——同步发送正常 sendEmail.delay('异步发送信息') ——celery异步发送失败报错Connection unexpectedly closed ……

Python __init__.py 包导入问题

今天写代码的时候遇到了一个问题,我自己写了一个包address。 其中__init__.py内容如下: __all__ = ['cpca', 'regulate'] 然后在外面文件夹建立了一个test.py准备使用这个包 发现导入遇到了一些问题 在test.py中只用import导入会报错找不到 import address print(address.regulate.index_address) 报错:module 'address' has no attribute 'regulate' 而通过from xxx import 就没有问题 from address import regulate print(regulate.index_address) 很好奇这个问题,虽然不影响正常编写,但是出于求真心理,很想知道是为什么,如果有知道的小伙伴希望可以解答一下,谢谢~

Django-cas 单点登录求助大神

报错信息: [Errno socket error] [Errno 1] _ssl.c:504: error:14077438:SSL routines:SSL23_GET_SERVER_HELLO:tlsv1 alert internal error Django Setting文件里面已经安装配置配置了,附上setting部分代码: INSTALLED_APPS = ( 'django.contrib.admin', 'django.contrib.auth', 'django.contrib.contenttypes', 'django.contrib.sessions', 'django.contrib.messages', 'django.contrib.staticfiles', #'django_cas', ) MIDDLEWARE_CLASSES = ( 'django.contrib.sessions.middleware.SessionMiddleware', 'django.middleware.common.CommonMiddleware', 'django.middleware.csrf.CsrfViewMiddleware', 'django.contrib.auth.middleware.AuthenticationMiddleware', 'django.contrib.messages.middleware.MessageMiddleware', 'django.middleware.clickjacking.XFrameOptionsMiddleware', 'django_cas.middleware.CASMiddleware', 'django.middleware.doc.XViewMiddleware', ) AUTHENTICATION_BACKENDS = ( 'django.contrib.auth.backends.ModelBackend', 'django_cas.backends.CASBackend', ) CAS_SERVER_URL=‘xxx.xxx.xxx/login’

python从入门到实践中,学习笔记项目,用户登录出错:

Environment: Request Method: GET Request URL: http://127.0.0.1:8000/users/login/ Django Version: 2.2.4 Python Version: 3.7.3 Installed Applications: ['django.contrib.admin', 'django.contrib.auth', 'django.contrib.contenttypes', 'django.contrib.sessions', 'django.contrib.messages', 'django.contrib.staticfiles', 'learning_logs', 'users'] Installed Middleware: ['django.middleware.security.SecurityMiddleware', 'django.contrib.sessions.middleware.SessionMiddleware', 'django.middleware.common.CommonMiddleware', 'django.middleware.csrf.CsrfViewMiddleware', 'django.contrib.auth.middleware.AuthenticationMiddleware', 'django.contrib.messages.middleware.MessageMiddleware', 'django.middleware.clickjacking.XFrameOptionsMiddleware'] Traceback: File "C:\Users\风骚小孔\learning_log\ll_env\lib\site-packages\django\core\handlers\exception.py" in inner 34. response = get_response(request) File "C:\Users\风骚小孔\learning_log\ll_env\lib\site-packages\django\core\handlers\base.py" in _get_response 115. response = self.process_exception_by_middleware(e, request) File "C:\Users\风骚小孔\learning_log\ll_env\lib\site-packages\django\core\handlers\base.py" in _get_response 113. response = wrapped_callback(request, *callback_args, **callback_kwargs) Exception Type: TypeError at /users/login/ Exception Value: __init__() takes 1 positional argument but 2 were given 这是按照Traceback找到的错误代码位置 ![图片说明](https://img-ask.csdn.net/upload/201908/24/1566606675_487568.png)![图片说明](https://img-ask.csdn.net/upload/201908/24/1566606706_436374.png) 感谢大神解惑

django_pyodbc写sqlserver中文乱码问题

CentOS平台,系统和脚本文件都是UTF-8字符集,数据库配置如下: 'OPTIONS':{ 'host_is_server': True, 'unicode_results': True, 'collations': 'Chinese_PRC_CI_AS', 'encoding': 'cp936', }, unicode_results字段官网没有,加上后才能解决查询结果乱码问题。使用官网的encoding设置一直解决不了插入数据中文乱码,修改成utf-8或cp936等都无效。 数据库采用的是CP936编码,无法变更,请高人指点,谢谢!

django-admin中重写了get_readonly_fields方法后页面上对应字段没了。

django-admin中重写了get_readonly_fields方法后页面上‘name’字段没了, 我本意是想把‘name’变成只可显示不可修改的, 这是什么情况,大神求指导啊。 class SubprojectInline(object): model = Subproject style = 'accordion' extra=1 def get_readonly_fields(self): readonly_fields=['name'] return readonly_fields

uwsgi启动django项目报错

Traceback (most recent call last):   File "./AdminSystem/wsgi.py", line 12, in <module>     from django.core.wsgi import get_wsgi_application ImportError: No module named django.core.wsgi unable to load app 0 (mountpoint='') (callable not found or import error) --- no python application found, check your startup logs for errors --- 这是我的uwsgi.ini的配置 ![图片说明](https://img-ask.csdn.net/upload/202004/03/1585879873_469250.png)

执行python manage.py migrate命令有问题

我在windows系统搭建了开发环境,使用的是pytohn2.7版本,在本地开发环境验证测试,执行python manage.py migrate命令有问题: 我在这个位置执行的命令: ![图片说明](https://img-ask.csdn.net/upload/201912/16/1576467780_425609.png) 报错如下: ![图片说明](https://img-ask.csdn.net/upload/201912/16/1576467889_633346.png) D:\python2.7\python2.7\Lib\site-packages\django\conf\project_template>python manage.py migrate Traceback (most recent call last): File "manage.py", line 10, in <module> execute_from_command_line(sys.argv) File "D:\python2.7\python2.7\lib\site-packages\django\core\management\__init__.py", line 338, in execute_from_command_line utility.execute() File "D:\python2.7\python2.7\lib\site-packages\django\core\management\__init__.py", line 303, in execute settings.INSTALLED_APPS File "D:\python2.7\python2.7\lib\site-packages\django\conf\__init__.py", line 48, in __getattr__ self._setup(name) File "D:\python2.7\python2.7\lib\site-packages\django\conf\__init__.py", line 44, in _setup self._wrapped = Settings(settings_module) File "D:\python2.7\python2.7\lib\site-packages\django\conf\__init__.py", line 92, in __init__ mod = importlib.import_module(self.SETTINGS_MODULE) File "D:\python2.7\python2.7\lib\importlib\__init__.py", line 37, in import_module __import__(name) ImportError: No module named {{ project_name }}.settings 求大神指教,是我执行的目录位置有问题吗?

django中 django.db.utils.ProgrammingError: (1146, "Table 'xxx' doesn't exist")的问题

新上手django,为了测试,对其中一个app 进行了 很多次 makemigrations 和 migrate(主要是做了数据库的变更),现在报错, 显示django.db.utils.ProgrammingError: (1146, "Table 'xxx' doesn't exist") 如下图所示: ![图片说明](https://img-ask.csdn.net/upload/201812/26/1545814038_212243.png) 但是这个表明明存在:如下图所示: ![图片说明](https://img-ask.csdn.net/upload/201812/26/1545814070_231776.png) 以下为makemigrations的信息: 001initial.py ![图片说明](https://img-ask.csdn.net/upload/201812/26/1545814223_588095.png) 002.py ![图片说明](https://img-ask.csdn.net/upload/201812/26/1545814296_762669.png) 003.py ![图片说明](https://img-ask.csdn.net/upload/201812/26/1545814308_915151.png) 004.py ![图片说明](https://img-ask.csdn.net/upload/201812/26/1545814322_193149.png) 005.py ![图片说明](https://img-ask.csdn.net/upload/201812/26/1545814330_536118.png) 第二个问题: 其中还有几次报错是 1054 Unknown column ‘tableName.id' in 'field list' 但是表中并没有id这个字段,是什么原因呢? 是不是这个app的model没有映射到相应的数据表呢?

Django下拉列表提交数据验证form.is_valid()为False,请问该如何解决?

Django下拉列表提交数据验证form.is_valid()为False,请问该如何解决?相关代码块如下: models: ``` class ZhuanJia(models.Model): zhuanye = models.CharField(max_length=50, verbose_name='从事专业') class Meta: verbose_name = '专家信息' verbose_name_plural = verbose_name def __str__(self): return self.zhuanye ``` forms: ``` class AddForm(forms.Form): CHOICE=ZhuanJia.objects.values_list('zhuanye', flat="True").distinct() print(type(CHOICE)) zhuanye = forms.ModelChoiceField( queryset=CHOICE, empty_label='请选择专业类别', label='选择专业', required=True, ) ``` views: ``` def index(request): if request.method == 'POST': # POST form = AddForm(request.POST) print('返回的表单是否绑定了数据:',form.is_bound) print('返回的POST是:\n',request.POST) print('数据有效性验证:',form.is_valid()) print('错误信息:',form.errors) if form.is_valid(): form = form.cleaned_data['zhuanye'] return render(request, 'chouqu/xuanze.html', {'form': form}) else: # GET form = AddForm() return render(request, 'chouqu/chouqu.html', {'form': form}) ``` 前端: ``` <form action="" method="post" class="juzhong"> {% csrf_token %} {{form}} <input type="submit" value="提交"> ``` 终端打印出来的信息: ``` 返回的表单是否绑定了数据: True 返回的POST是: <QueryDict: {'csrfmiddlewaretoken': ['6ByVOxfTn22vsx5LmxQHSaewR9mDwqFsO76EAqOEyNqQK3bEjMhcaM1QZ6YUckf7'], 'zhuanye': ['水利工程']}> 数据有效性验证: False 错误信息: <ul class="errorlist"><li>zhuanye<ul class="errorlist"><li>选择一个有效的选项: 该选择不在可用的选项中。</li></ul></li></ul> ```

python报这个错误如何解决

python3 manage.py runserver Traceback (most recent call last): File "/usr/local/lib/python3.5/dist-packages/django/core/management/__init__.py", line 357, in execute autoreload.check_errors(django.setup)() File "/usr/local/lib/python3.5/dist-packages/django/utils/autoreload.py", line 53, in wrapper fn(*args, **kwargs) File "/usr/local/lib/python3.5/dist-packages/django/__init__.py", line 16, in setup from django.urls import set_script_prefix File "/usr/local/lib/python3.5/dist-packages/django/urls/__init__.py", line 1, in <module> from .base import ( File "/usr/local/lib/python3.5/dist-packages/django/urls/base.py", line 9, in <module> from .exceptions import NoReverseMatch, Resolver404 File "/usr/local/lib/python3.5/dist-packages/django/urls/exceptions.py", line 1, in <module> from django.http import Http404 File "/usr/local/lib/python3.5/dist-packages/django/http/__init__.py", line 2, in <module> from django.http.request import ( File "/usr/local/lib/python3.5/dist-packages/django/http/request.py", line 10, in <module> from django.core import signing File "/usr/local/lib/python3.5/dist-packages/django/core/signing.py", line 45, in <module> from django.utils.crypto import constant_time_compare, salted_hmac File "/usr/local/lib/python3.5/dist-packages/django/utils/crypto.py", line 6, in <module> import secrets ImportError: No module named 'secrets' During handling of the above exception, another exception occurred: Traceback (most recent call last): File "manage.py", line 15, in <module> execute_from_command_line(sys.argv) File "/usr/local/lib/python3.5/dist-packages/django/core/management/__init__.py", line 401, in execute_from_command_line utility.execute() File "/usr/local/lib/python3.5/dist-packages/django/core/management/__init__.py", line 370, in execute _parser = self.fetch_command('runserver').create_parser('django', 'runserver') File "/usr/local/lib/python3.5/dist-packages/django/core/management/__init__.py", line 244, in fetch_command klass = load_command_class(app_name, subcommand) File "/usr/local/lib/python3.5/dist-packages/django/core/management/__init__.py", line 37, in load_command_class module = import_module('%s.management.commands.%s' % (app_name, name)) File "/usr/lib/python3.5/importlib/__init__.py", line 126, in import_module return _bootstrap._gcd_import(name[level:], package, level) File "<frozen importlib._bootstrap>", line 986, in _gcd_import File "<frozen importlib._bootstrap>", line 969, in _find_and_load File "<frozen importlib._bootstrap>", line 958, in _find_and_load_unlocked File "<frozen importlib._bootstrap>", line 673, in _load_unlocked File "<frozen importlib._bootstrap_external>", line 665, in exec_module File "<frozen importlib._bootstrap>", line 222, in _call_with_frames_removed File "/usr/local/lib/python3.5/dist-packages/django/core/management/commands/runserver.py", line 10, in <module> from django.core.servers.basehttp import ( File "/usr/local/lib/python3.5/dist-packages/django/core/servers/basehttp.py", line 17, in <module> from django.core.handlers.wsgi import LimitedStream File "/usr/local/lib/python3.5/dist-packages/django/core/handlers/wsgi.py", line 6, in <module> from django.core.handlers import base File "/usr/local/lib/python3.5/dist-packages/django/core/handlers/base.py", line 8, in <module> from django.urls import get_resolver, set_urlconf File "/usr/local/lib/python3.5/dist-packages/django/urls/__init__.py", line 1, in <module> from .base import ( File "/usr/local/lib/python3.5/dist-packages/django/urls/base.py", line 9, in <module> from .exceptions import NoReverseMatch, Resolver404 File "/usr/local/lib/python3.5/dist-packages/django/urls/exceptions.py", line 1, in <module> from django.http import Http404 File "/usr/local/lib/python3.5/dist-packages/django/http/__init__.py", line 2, in <module> from django.http.request import ( File "/usr/local/lib/python3.5/dist-packages/django/http/request.py", line 10, in <module> from django.core import signing File "/usr/local/lib/python3.5/dist-packages/django/core/signing.py", line 45, in <module> from django.utils.crypto import constant_time_compare, salted_hmac File "/usr/local/lib/python3.5/dist-packages/django/utils/crypto.py", line 6, in <module> import secrets ImportError: No module named 'secrets'

django2.13+xadmin 后台删除数据报错问题

我的django是 2.13版本的 xadmin是从github新下载的版本。 我在后台管理界面 删除一条数据后 报错,提示: get_deleted_objects() takes 3 positional arguments but 5 were given Location:\xadmin\plugins\actions.py in do_action, line 94 网上的办法适用于django2.0版本 请大神帮忙解决下

django使用@login_required时出现重定向次数过多问题是怎么回事

报错如下: ![图片说明](https://img-ask.csdn.net/upload/201908/23/1566554722_363027.png) 目录如下: ![图片说明](https://img-ask.csdn.net/upload/201908/23/1566554300_221679.png) index的views.py: ![图片说明](https://img-ask.csdn.net/upload/201908/23/1566554666_927148.png) login的views.py: ``` from django.shortcuts import render, redirect from .forms import * # Create your views here. def login_views(request): if request.method == 'GET': # 获取请求源地址,如果没有的话则获取'/' url = request.META.get('HTTP_REFERER', '/') # print("请求源地址:"+url) # 判断session中是否有uid和uname if 'uid' in request.session and 'uname' in request.session: return redirect(url) else: # 判断cookie中是否有uid和uname, if 'uid' in request.COOKIES and 'uname' in request.COOKIES: # 如果有的话则取出来并保存进session,再回首页 uid = request.COOKIES['uid'] uname = request.COOKIES['uname'] request.session['uid'] = uid request.session['uname'] = uname return redirect(url) else: form = LoginForm() # 构建响应对象,并将url保存进cookies resp = render(request, 'login.html', locals()) resp.set_cookie('url', url) return resp else: # post请求 # 获取请求源地址 url = request.META.get('HTTP_REFERER', '/') # 接收uname和upwd判断是否登录成功 uname = request.POST['uname'] upwd = request.POST['upwd'] user_name = Users.objects.filter(uname=uname) users = Users.objects.filter(uname=uname, upwd=upwd) # 如果成功继续向下执行,否则回到登录页 if users: # 登录成功,将id和uname保存进session id = users[0].id request.session['uid'] = id request.session['uname'] = uname # 如果有记住密码则将数据保存进cookies # 先从cookies中将url的值获取出来 url = request.COOKIES.get('url', '/') resp = redirect(url) # 如果url存在于cookies中的话,则将url从cookies中删除出去 if 'url' in request.COOKIES: resp.delete_cookie('url') if 'isSave' in request.POST: expires = 60 * 60 * 24 * 365 resp.set_cookie('uid', id, expires) resp.set_cookie('uname', uname, expires) return resp else: # 登录失败,回到登录页面 message = '登录失败!' return redirect('/login/') ```

django OperationalError:no such table问题

admin界面有这些table ![图片说明](https://img-ask.csdn.net/upload/201908/20/1566306109_375484.png) 但任何一张表打开都是operationalerror ![图片说明](https://img-ask.csdn.net/upload/201908/20/1566306079_894027.png) 我的数据库 ![图片说明](https://img-ask.csdn.net/upload/201908/20/1566306954_557961.png) 文件路径 ![图片说明](https://img-ask.csdn.net/upload/201908/20/1566307025_838507.png) 运行过如下代码 ``` python manage.py makemigrations python manage.py migrate ``` ![图片说明](https://img-ask.csdn.net/upload/201908/20/1566306389_902239.png) ![图片说明](https://img-ask.csdn.net/upload/201908/20/1566306436_170968.png) 我觉得应该是运行成功了的 以下这些我找到的解决方法都试过了没有用 ``` python manage.py syncdb class Meta: managed = True python manage.py makemigrations HERBS python manage.py migrate HERBS ``` admin.py ``` from django.contrib import admin from HERBS.models import Herbs,DISEASE,Chemicals,CASID,TARGET class HerbAdmin(admin.ModelAdmin): search_fields = ('ID','NAME') #可进行查询的字段 list_filter = ('NAME','Function') #可进行筛选的字段 list_display = ('ID','NAME','Function') #需要在后台显示出来的字段 class DISEASEAdmin(admin.ModelAdmin): search_fields = ('Disease','MolID') list_filter = ('Disease','MolID') list_display = ('Disease','MolID') class ChemicalsAdmin(admin.ModelAdmin): search_fields = ('ChemName','MolID','PubChemcid','ChineseName','Smiles') list_filter = ('MolID','ChemName') list_display = ('ChemName','MolID','PubChemcid','HID','ChineseName','MF','MW','Smiles') class CASIDAdmin(admin.ModelAdmin): search_fields = ('ID','MolID') list_display = ('ID','MolID') class TARGETAdmin(admin.ModelAdmin): search_fields = ('MolID','Target') list_display = ('MolID','Target') # Register your models here. admin.site.register(Herbs,HerbAdmin) admin.site.register(DISEASE,DISEASEAdmin) admin.site.register(CASID,CASIDAdmin) admin.site.register(Chemicals,ChemicalsAdmin) admin.site.register(TARGET,TARGETAdmin) ``` models.py ``` from django.db import models #Create your models here. class Herbs(models.Model): ID = models.DecimalField(max_digits=5,decimal_places=0) NAME = models.TextField(max_length=50,primary_key=True) Function = models.TextField(max_length=500,null=True) class DISEASE(models.Model): Disease = models.TextField(max_length=100) MolID = models.TextField(max_length=50) class Chemicals(models.Model): ChemName = models.TextField(max_length=50) MolID = models.TextField(max_length=50) PubChemcid = models.DecimalField(max_digits=10,decimal_places=0) HID = models.DecimalField(max_digits=10,decimal_places=0) ChineseName = models.TextField(max_length=50) MF = models.TextField(max_length=50) MW = models.DecimalField(max_digits=20,decimal_places=2) Smiles = models.TextField(max_length=500) class CASID(models.Model): ID = models.TextField(max_length=50) MolID = models.TextField(max_length=50) class TARGET(models.Model): Target = models.TextField(max_length=100) MolID = models.TextField(max_length=50) class Meta: managed = True ```

django创建项目时,urls.py报错:No module named 'index.urls'

django创建音乐网站项目时,urls.py写入代码后,pycharm一直报错: No module named 'index.urls' 用idle运行时候就报错: Requested setting INSTALLED_APPS, but settings are not configured. You must either define the environment variable DJANGO_SETTINGS_MODULE or call settings.configure() before accessing settings. 创建过程中只修改了urls.py 和setting.py 文件 代码如下: [b]urls.py[/b] from django.contrib import admin from django.urls import path, include from django.conf.urls import url from django.views import static from django.conf import settings urlpatterns = [ path('admin/', admin.site.urls), path('', include('index.urls')), path('ranking.html', include('ranking.urls')), path('play/', include('play.urls')), path('comment/', include('comment.urls')), path('search/', include('search.urls')), path('user/', include('user.urls')), ] [b]settings.py[/b] (部分代码) INSTALLED_APPS = [ 'django.contrib.admin', 'django.contrib.auth', 'django.contrib.contenttypes', 'django.contrib.sessions', 'django.contrib.messages', 'django.contrib.staticfiles', 'index', 'ranking', 'user', 'play', 'search', 'comment', ] MIDDLEWARE = [ 'django.middleware.security.SecurityMiddleware', 'django.contrib.sessions.middleware.SessionMiddleware', # 使用中文 'django.middleware.locale.LocaleMiddleware', 'django.middleware.common.CommonMiddleware', 'django.middleware.csrf.CsrfViewMiddleware', 'django.contrib.auth.middleware.AuthenticationMiddleware', 'django.contrib.messages.middleware.MessageMiddleware', 'django.middleware.clickjacking.XFrameOptionsMiddleware', ] ROOT_URLCONF = 'music.urls' TEMPLATES = [ { 'BACKEND': 'django.template.backends.django.DjangoTemplates', 'DIRS': [ os.path.join(BASE_DIR, 'templates'), os.path.join(BASE_DIR, 'index/templates'), os.path.join(BASE_DIR, 'ranking/templates'), os.path.join(BASE_DIR, 'user/templates'), os.path.join(BASE_DIR, 'play/templates'), os.path.join(BASE_DIR, 'comment/templates'), ], 'APP_DIRS': True, 'OPTIONS': { 'context_processors': [ 'django.template.context_processors.debug', 'django.template.context_processors.request', 'django.contrib.auth.context_processors.auth', 'django.contrib.messages.context_processors.messages', ], }, }, ] WSGI_APPLICATION = 'music.wsgi.application' DATABASES = { 'default': { 'ENGINE': 'django.db.backends.mysql', 'NAME': 'music_db', 'USER': 'root', 'PASSWORD': '1234', 'HOST': '127.0.0.1', 'POST': '3306', } } 请问这种情况该如何处理呢?求指点

关于Django执行迁移文件时,ForeignKey里面加on_delete=models.CASCADE报错问题,谁知道时怎么回事?万分感谢!!

Django 在创建模型类后,执行一下代码迁移文件时,在ForeignKey里面不加on_delete=models.CASCADE会报错,加了后,其他又外键的模型类不报错,就这个报错。 ``` class GoodsType(BaseModel): """商品类型模型类""" name = models.CharField(max_length=20, verbose_name="种类名称") logo = models.CharField(max_length=20, verbose_name="标识") image = models.ImageField(upload_to="type", verbose_name="商品类型图片") class Mete: db_table = "df_goods_type" verbose_name = "商品种类" verbose_name_plural = verbose_name def __str__(self): return self.name class GoodsSKU(BaseModel): """商品SKU模型类""" status_choices = ( (0, "下线"), (1, "上线"), ) type = models.ForeignKey("GoodsType", on_delete=models.CASCADE, verbose_name="商品种类") goods = models.ForeignKey("Goods", on_delete=models.CASCADE, verbose_name="商品SPU") name = models.CharField(max_length=20, verbose_name="商品名称") desc = models.CharField(max_length=256, verbose_name="商品简介") price = models.DecimalField(max_digits=10, decimal_places=2, verbose_name="商品价格") unite = models.CharField(max_length=20, verbose_name="商品单位") image = models.ImageField(upload_to='goods', verbose_name="商品图片") stock = models.IntegerField(default=1, verbose_name="商品库存") sales = models.IntegerField(default=0, verbose_name="商品销量") status = models.SmallIntegerField(default=1, choices=status_choices,verbose_name="商品状态") class Meta: db_table = "df_goods_sku" verbose_name = "商品" verbose_name_plural = verbose_name class GoodImage(models): """商品图片模型类""" sku = models.ForeignKey("GoodsSKU", on_delete=models.CASCADE, verbose_name="商品") image = models.ImageField(upload_to="good", verbose_name="图片路径") class Meta: db_table = "df_goods_image" verbose_name = "商品图片" verbose_name_plural = verbose_name ``` 报错 ``` python manage.py makemigrations Traceback (most recent call last): File "manage.py", line 21, in <module> main() File "manage.py", line 17, in main execute_from_command_line(sys.argv) File "/home/u/.virtualenvs/dailyfresh/lib/python3.5/site-packages/django/core/management/__init__.py", line 381, in execute_from_command_line utility.execute() File "/home/u/.virtualenvs/dailyfresh/lib/python3.5/site-packages/django/core/management/__init__.py", line 357, in execute django.setup() File "/home/u/.virtualenvs/dailyfresh/lib/python3.5/site-packages/django/__init__.py", line 24, in setup apps.populate(settings.INSTALLED_APPS) File "/home/u/.virtualenvs/dailyfresh/lib/python3.5/site-packages/django/apps/registry.py", line 114, in populate app_config.import_models() File "/home/u/.virtualenvs/dailyfresh/lib/python3.5/site-packages/django/apps/config.py", line 211, in import_models self.models_module = import_module(models_module_name) File "/usr/lib/python3.5/importlib/__init__.py", line 126, in import_module return _bootstrap._gcd_import(name[level:], package, level) File "<frozen importlib._bootstrap>", line 986, in _gcd_import File "<frozen importlib._bootstrap>", line 969, in _find_and_load File "<frozen importlib._bootstrap>", line 958, in _find_and_load_unlocked File "<frozen importlib._bootstrap>", line 673, in _load_unlocked File "<frozen importlib._bootstrap_external>", line 665, in exec_module File "<frozen importlib._bootstrap>", line 222, in _call_with_frames_removed File "/home/u/jeth/dailyfresh/apps/goods/models.py", line 56, in <module> class GoodImage(models): TypeError: module.__init__() takes at most 2 arguments (3 given) ```

在中国程序员是青春饭吗?

今年,我也32了 ,为了不给大家误导,咨询了猎头、圈内好友,以及年过35岁的几位老程序员……舍了老脸去揭人家伤疤……希望能给大家以帮助,记得帮我点赞哦。 目录: 你以为的人生 一次又一次的伤害 猎头界的真相 如何应对互联网行业的「中年危机」 一、你以为的人生 刚入行时,拿着傲人的工资,想着好好干,以为我们的人生是这样的: 等真到了那一天,你会发现,你的人生很可能是这样的: ...

程序员请照顾好自己,周末病魔差点一套带走我。

程序员在一个周末的时间,得了重病,差点当场去世,还好及时挽救回来了。

我以为我学懂了数据结构,直到看了这个导图才发现,我错了

数据结构与算法思维导图

String s = new String(" a ") 到底产生几个对象?

老生常谈的一个梗,到2020了还在争论,你们一天天的,哎哎哎,我不是针对你一个,我是说在座的各位都是人才! 上图红色的这3个箭头,对于通过new产生一个字符串(”宜春”)时,会先去常量池中查找是否已经有了”宜春”对象,如果没有则在常量池中创建一个此字符串对象,然后堆中再创建一个常量池中此”宜春”对象的拷贝对象。 也就是说准确答案是产生了一个或两个对象,如果常量池中原来没有 ”宜春” ,就是两个。...

技术大佬:我去,你写的 switch 语句也太老土了吧

昨天早上通过远程的方式 review 了两名新来同事的代码,大部分代码都写得很漂亮,严谨的同时注释也很到位,这令我非常满意。但当我看到他们当中有一个人写的 switch 语句时,还是忍不住破口大骂:“我擦,小王,你丫写的 switch 语句也太老土了吧!” 来看看小王写的代码吧,看完不要骂我装逼啊。 private static String createPlayer(PlayerTypes p...

Linux面试题(2020最新版)

文章目录Linux 概述什么是LinuxUnix和Linux有什么区别?什么是 Linux 内核?Linux的基本组件是什么?Linux 的体系结构BASH和DOS之间的基本区别是什么?Linux 开机启动过程?Linux系统缺省的运行级别?Linux 使用的进程间通信方式?Linux 有哪些系统日志文件?Linux系统安装多个桌面环境有帮助吗?什么是交换空间?什么是root帐户什么是LILO?什...

将一个接口响应时间从2s优化到 200ms以内的一个案例

一、背景 在开发联调阶段发现一个接口的响应时间特别长,经常超时,囧… 本文讲讲是如何定位到性能瓶颈以及修改的思路,将该接口从 2 s 左右优化到 200ms 以内 。 二、步骤 2.1 定位 定位性能瓶颈有两个思路,一个是通过工具去监控,一个是通过经验去猜想。 2.1.1 工具监控 就工具而言,推荐使用 arthas ,用到的是 trace 命令 具体安装步骤很简单,大家自行研究。 我的使用步骤是...

学历低,无法胜任工作,大佬告诉你应该怎么做

微信上收到一位读者小涛的留言,大致的意思是自己只有高中学历,经过培训后找到了一份工作,但很难胜任,考虑要不要辞职找一份他能力可以胜任的实习工作。下面是他留言的一部分内容: 二哥,我是 2016 年高中毕业的,考上了大学但没去成,主要是因为当时家里经济条件不太允许。 打工了三年后想学一门技术,就去培训了。培训的学校比较垃圾,现在非常后悔没去正规一点的机构培训。 去年 11 月份来北京找到了一份工...

JVM内存结构和Java内存模型别再傻傻分不清了

JVM内存结构和Java内存模型都是面试的热点问题,名字看感觉都差不多,网上有些博客也都把这两个概念混着用,实际上他们之间差别还是挺大的。 通俗点说,JVM内存结构是与JVM的内部存储结构相关,而Java内存模型是与多线程编程相关,本文针对这两个总是被混用的概念展开讲解。 JVM内存结构 JVM构成 说到JVM内存结构,就不会只是说内存结构的5个分区,而是会延展到整个JVM相关的问题,所以先了解下

和黑客斗争的 6 天!

互联网公司工作,很难避免不和黑客们打交道,我呆过的两家互联网公司,几乎每月每天每分钟都有黑客在公司网站上扫描。有的是寻找 Sql 注入的缺口,有的是寻找线上服务器可能存在的漏洞,大部分都...

Google 与微软的浏览器之争

浏览器再现“神仙打架”。整理 | 屠敏头图 | CSDN 下载自东方 IC出品 | CSDN(ID:CSDNnews)从 IE 到 Chrome,再从 Chrome 到 Edge,微软与...

讲一个程序员如何副业月赚三万的真实故事

loonggg读完需要3分钟速读仅需 1 分钟大家好,我是你们的校长。我之前讲过,这年头,只要肯动脑,肯行动,程序员凭借自己的技术,赚钱的方式还是有很多种的。仅仅靠在公司出卖自己的劳动时...

上班一个月,后悔当初着急入职的选择了

最近有个老铁,告诉我说,上班一个月,后悔当初着急入职现在公司了。他之前在美图做手机研发,今年美图那边今年也有一波组织优化调整,他是其中一个,在协商离职后,当时捉急找工作上班,因为有房贷供着,不能没有收入来源。所以匆忙选了一家公司,实际上是一个大型外包公司,主要派遣给其他手机厂商做外包项目。**当时承诺待遇还不错,所以就立马入职去上班了。但是后面入职后,发现薪酬待遇这块并不是HR所说那样,那个HR自...

女程序员,为什么比男程序员少???

昨天看到一档综艺节目,讨论了两个话题:(1)中国学生的数学成绩,平均下来看,会比国外好?为什么?(2)男生的数学成绩,平均下来看,会比女生好?为什么?同时,我又联想到了一个技术圈经常讨...

搜狗输入法也在挑战国人的智商!

故事总是一个接着一个到来...上周写完《鲁大师已经彻底沦为一款垃圾流氓软件!》这篇文章之后,鲁大师的市场工作人员就找到了我,希望把这篇文章删除掉。经过一番沟通我先把这篇文章从公号中删除了...

85后蒋凡:28岁实现财务自由、34岁成为阿里万亿电商帝国双掌门,他的人生底层逻辑是什么?...

蒋凡是何许人也? 2017年12月27日,在入职4年时间里,蒋凡开挂般坐上了淘宝总裁位置。 为此,时任阿里CEO张勇在任命书中力赞: 蒋凡加入阿里,始终保持创业者的冲劲,有敏锐的...

总结了 150 余个神奇网站,你不来瞅瞅吗?

原博客再更新,可能就没了,之后将持续更新本篇博客。

副业收入是我做程序媛的3倍,工作外的B面人生是怎样的?

提到“程序员”,多数人脑海里首先想到的大约是:为人木讷、薪水超高、工作枯燥…… 然而,当离开工作岗位,撕去层层标签,脱下“程序员”这身外套,有的人生动又有趣,马上展现出了完全不同的A/B面人生! 不论是简单的爱好,还是正经的副业,他们都干得同样出色。偶尔,还能和程序员的特质结合,产生奇妙的“化学反应”。 @Charlotte:平日素颜示人,周末美妆博主 大家都以为程序媛也个个不修边幅,但我们也许...

MySQL数据库面试题(2020最新版)

文章目录数据库基础知识为什么要使用数据库什么是SQL?什么是MySQL?数据库三大范式是什么mysql有关权限的表都有哪几个MySQL的binlog有有几种录入格式?分别有什么区别?数据类型mysql有哪些数据类型引擎MySQL存储引擎MyISAM与InnoDB区别MyISAM索引与InnoDB索引的区别?InnoDB引擎的4大特性存储引擎选择索引什么是索引?索引有哪些优缺点?索引使用场景(重点)...

如果你是老板,你会不会踢了这样的员工?

有个好朋友ZS,是技术总监,昨天问我:“有一个老下属,跟了我很多年,做事勤勤恳恳,主动性也很好。但随着公司的发展,他的进步速度,跟不上团队的步伐了,有点...

我入职阿里后,才知道原来简历这么写

私下里,有不少读者问我:“二哥,如何才能写出一份专业的技术简历呢?我总感觉自己写的简历太烂了,所以投了无数份,都石沉大海了。”说实话,我自己好多年没有写过简历了,但我认识的一个同行,他在阿里,给我说了一些他当年写简历的方法论,我感觉太牛逼了,实在是忍不住,就分享了出来,希望能够帮助到你。 01、简历的本质 作为简历的撰写者,你必须要搞清楚一点,简历的本质是什么,它就是为了来销售你的价值主张的。往深...

离职半年了,老东家又发 offer,回不回?

有小伙伴问松哥这个问题,他在上海某公司,在离职了几个月后,前公司的领导联系到他,希望他能够返聘回去,他很纠结要不要回去? 俗话说好马不吃回头草,但是这个小伙伴既然感到纠结了,我觉得至少说明了两个问题:1.曾经的公司还不错;2.现在的日子也不是很如意。否则应该就不会纠结了。 老实说,松哥之前也有过类似的经历,今天就来和小伙伴们聊聊回头草到底吃不吃。 首先一个基本观点,就是离职了也没必要和老东家弄的苦...

男生更看重女生的身材脸蛋,还是思想?

往往,我们看不进去大段大段的逻辑。深刻的哲理,往往短而精悍,一阵见血。问:产品经理挺漂亮的,有点心动,但不知道合不合得来。男生更看重女生的身材脸蛋,还是...

什么时候跳槽,为什么离职,你想好了么?

都是出来打工的,多为自己着想

程序员为什么千万不要瞎努力?

本文作者用对比非常鲜明的两个开发团队的故事,讲解了敏捷开发之道 —— 如果你的团队缺乏统一标准的环境,那么即使勤劳努力,不仅会极其耗时而且成果甚微,使用...

为什么程序员做外包会被瞧不起?

二哥,有个事想询问下您的意见,您觉得应届生值得去外包吗?公司虽然挺大的,中xx,但待遇感觉挺低,马上要报到,挺纠结的。

当HR压你价,说你只值7K,你该怎么回答?

当HR压你价,说你只值7K时,你可以流畅地回答,记住,是流畅,不能犹豫。 礼貌地说:“7K是吗?了解了。嗯~其实我对贵司的面试官印象很好。只不过,现在我的手头上已经有一份11K的offer。来面试,主要也是自己对贵司挺有兴趣的,所以过来看看……”(未完) 这段话主要是陪HR互诈的同时,从公司兴趣,公司职员印象上,都给予对方正面的肯定,既能提升HR的好感度,又能让谈判气氛融洽,为后面的发挥留足空间。...

面试:第十六章:Java中级开发(16k)

HashMap底层实现原理,红黑树,B+树,B树的结构原理 Spring的AOP和IOC是什么?它们常见的使用场景有哪些?Spring事务,事务的属性,传播行为,数据库隔离级别 Spring和SpringMVC,MyBatis以及SpringBoot的注解分别有哪些?SpringMVC的工作原理,SpringBoot框架的优点,MyBatis框架的优点 SpringCould组件有哪些,他们...

面试阿里p7,被按在地上摩擦,鬼知道我经历了什么?

面试阿里p7被问到的问题(当时我只知道第一个):@Conditional是做什么的?@Conditional多个条件是什么逻辑关系?条件判断在什么时候执...

终于懂了TCP和UDP协议区别

终于懂了TCP和UDP协议区别

立即提问
相关内容推荐